/*
   IM Caf - A Java Based Instant Messaging System
   Author: Bruno Freitas - 08/2004
   Contact: bootsector@ig.com.br
 
   Copyright (c) 2004 Bruno Freitas
 
   Permission is hereby granted, free of charge, to any person obtaining a copy of
   this software and associated documentation files (the "Software"), to deal in
   the Software without restriction, including without limitation the rights to
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
   of the Software, and to permit persons to whom the Software is furnished to do
   so, subject to the following conditions:
 
   The above copyright notice and this permission notice shall be included in all
   copies or substantial portions of the Software.
 
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

import java.net.*;
import java.io.*;

public class ServerReader extends Thread {
   private ServerConnection sc;
   private InputStream is;
   private ClientMainWindow mainWindow;
   private ObjectInputStream ois;
   
   public ServerReader(Socket socket, ClientMainWindow mainWindow, ServerConnection sc) throws IOException {
      this.sc = sc;
      this.mainWindow = mainWindow;
      is = socket.getInputStream();
      ois = new ObjectInputStream(is);
   }
   
   public void run() {
      CommData data = null;
      
      while (true) {
         try {
            data = (CommData) ois.readObject();
            if (data != null)
               new DataHandler(data, mainWindow, sc).start();
            
         } catch (Exception e) {
            //if (e instanceof SocketException) {
            mainWindow.setStatusOffline();
            break;
            //}
            //else
            //   throw new RuntimeException(e);
         }
         
      }
      
   }
}
